// test.ino

#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
#include <math.h>                              
#include <Servo.h>                                 //Include Servo library
#define PIN 8
#define pin A6
SoftwareSerial mySerial(2,3);
Servo irservo;                                    // create servo object to control a servo 
#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, PIN, NEO_GRB + NEO_KHZ800);
#define Svo_Pin 10

int posnow;
int E1 = 5;     //M1 Speed Control
int E2 = 6;     //M2 Speed Control
int M1 = 4;     //M1 Direction Control
int M2 = 7;     //M1 Direction Control

void setup()
{ 
  mySerial.begin (9600);
  mp3_set_serial (mySerial);	//set Serial for DFPlayer-mini mp3 module 
  mp3_set_volume (15);
  mp3_play (7);
   delay (2000);
  
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  int i;
  for(i=4;i<=7;i++)
   pinMode(i, OUTPUT); 
//  pinMode(2,OUTPUT);
//  Serial.println("Run keyboard control");
  digitalWrite(E1,LOW);   
  digitalWrite(E2,LOW);
  irservo.attach(Svo_Pin);  
  //attaches the servo on pin 9 to the servo object 
  Serial.begin(19200);                            //Set Baud Rate
  advance(80,80);
}

int pos=0;                                        // variable to store the servo position 
float distance;

void loop()
{ 
 
   

while(1){ 
  for (int i=0;i<130;i++)          
  {
    irservo.write(i);

    uint16_t value = analogRead (pin);
    uint16_t range = get_distance (value);                   // connect the GP2Y0A21 distance sensor to Analog 6
    Serial.println(range);                    // print distance 
    if(range<10)
    {
    //  digitalWrite(2,LOW);delay(100); digitalWrite(2,HIGH); delay(100); 
      if(i<135)                           
      {
        back_off(130,130);delay(300);
        turn_L(130,130);delay(300);
      }
      else
      {
        back_off(130,130);delay(300);
        turn_R(130,130);delay(300);
      }

     advance(130,130);
    }
    delay(4);
  } 
 
  turn_R(130,130);
}


}

void stop(void)                    //Stop
{
  digitalWrite(E1,0); 
  digitalWrite(M1,LOW);    
  digitalWrite(E2,0);   
  digitalWrite(M2,LOW);
//  mp3_play (1);  
}   
void advance(char a,char b)          //Move forward
{
  analogWrite (E1,a);      //PWM Speed Control
  digitalWrite(M1,LOW);    
  analogWrite (E2,b);    
  digitalWrite(M2,LOW);
  colorWipe(strip.Color(0, 255, 255), 5); 
  mp3_play (2);
}  
void back_off (char a,char b)          //Move backward
{
  analogWrite (E1,a);
  digitalWrite(M1,HIGH);   
  analogWrite (E2,b);    
  digitalWrite(M2,HIGH);
  
  mp3_play (2);
}
void turn_R (char a,char b)             //Turn Left
{
  analogWrite (E1,a);
  digitalWrite(M1,LOW);    
  analogWrite (E2,b);    
  digitalWrite(M2,HIGH);
  colorWipe(strip.Color(255, 0, 255), 5); 
   //mp3_play (2);
}
void turn_L (char a,char b)             //Turn Right
{
  analogWrite (E1,a);
  digitalWrite(M1,HIGH);    
  analogWrite (E2,b);    
  digitalWrite(M2,LOW);
  colorWipe(strip.Color(255, 255, 0), 5); 
//  mp3_play (2);
}


    
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
    }}

uint16_t get_distance (uint16_t value) {
        if (value < 30)
                value = 30;
        return (((67870.0 / (value - 3.0)) - 40.0)/10);
}

